PGSQL_CONTROL
-- $Id: net_math.m4,v 1.1 2005/05/16 07:00:25 dem Exp $
CREATE OR REPLACE FUNCTION ipaggr_in(cstring) RETURNS ipaggr
 AS '$libdir/net_math.so.VMAJOR'
  , 'ipaggr_in'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION ipaggr_out(ipaggr) RETURNS cstring
 AS '$libdir/net_math.so.VMAJOR'
  , 'ipaggr_out'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION add_net(ipaggr,inet) RETURNS ipaggr
 AS '$libdir/net_math.so.VMAJOR'
  , 'add_net'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION show_net(ipaggr) RETURNS SETOF inet
 AS '$libdir/net_math.so.VMAJOR'
  , 'show_net'
 LANGUAGE C IMMUTABLE STRICT
;

CREATE AGGREGATE sum_net (
    sfunc = add_net,
    basetype = inet,
    stype = ipaggr,
    initcond = 'f'
);

CREATE TYPE ipaggr (
   internallength = VARIABLE, 
   input = ipaggr_in,
   output = ipaggr_out,
   alignment = double
);

COMMENT ON FUNCTION ipaggr_in(cstring)	IS '   IP ';
COMMENT ON FUNCTION ipaggr_out(ipaggr)	IS ' IP   ';
COMMENT ON FUNCTION add_net(ipaggr,inet)	IS '  IP  ';
COMMENT ON FUNCTION show_net(ipaggr)	IS ' IP    ';
COMMENT ON AGGREGATE sum_net(inet)	IS '   IP ';
